unit hiQProgressBar;

interface

uses Kol,Share,Win,Windows,KOLQProgBar;

const
  arr_Style : array[0..1] of TQBarKind        = ( bkFlat, bkCylinder );
  arr_Look  : array[0..1] of TQBarLook        = ( blMetal, blGlass );
  arr_Kind  : array[0..1] of TQBarOrientation = ( boHorizontal, boVertical );
  arr_Align : array[0..2] of TTextAlign       = ( taLeft, taCenter, taRight );  
  
type
  THIQProgressBar = class(THIWin)
   private
   public
    _prop_Color:             TColor;
    _prop_Caption:           string;
    _prop_Max:               integer;
    _prop_Kind:              byte;
// All
    _prop_BlockSize:         integer;
    _prop_SpaceSize:         integer;
    _prop_ShowFullBlock:     boolean;
    _prop_HideOnTerminate:   boolean;
// Gradient
    _prop_Style:             byte;
    _prop_Look:              byte; 
    _prop_StartColor:        TColor;
    _prop_FinalColor:        TColor;
    _prop_InactivePos:       boolean;    
    _prop_InvertInactPos:    boolean;
    _prop_InactivePosColor:  TColor;
// Text
    _prop_Alignment:         byte;
    _prop_AutoCaption:       boolean;
    _prop_AutoHint:          boolean;    
    _prop_ShowPosAsPct:      boolean;
// Border
    _prop_Shape:             boolean;
    _prop_ShapeColor:        TColor;
    _prop_Round:             boolean;
    
    procedure Init; override;
    procedure _work_doPosition          (var _Data:TData; Index:word);
    procedure _work_doMax               (var _Data:TData; Index:word);
    procedure _work_doColor             (var _Data:TData; Index:word);
    procedure _work_doKind              (var _Data:TData; Index:word);
// All
    procedure _work_doBlockSize         (var _Data:TData; Index:word);
    procedure _work_doSpaceSize         (var _Data:TData; Index:word);
    procedure _work_doShowFullBlock     (var _Data:TData; Index:word);
    procedure _work_doHideOnTerminate   (var _Data:TData; Index:word);
// Gradient
    procedure _work_doStyle             (var _Data:TData; Index:word);
    procedure _work_doLook              (var _Data:TData; Index:word);
    procedure _work_doStartColor        (var _Data:TData; Index:word);
    procedure _work_doFinalColor        (var _Data:TData; Index:word);
    procedure _work_doInactivePos       (var _Data:TData; Index:word);                        
    procedure _work_doInvertInactPos    (var _Data:TData; Index:word);
    procedure _work_doInactivePosColor  (var _Data:TData; Index:word);
// Text
    procedure _work_doAlignment         (var _Data:TData; Index:word);
    procedure _work_doAutoCaption       (var _Data:TData; Index:word);
    procedure _work_doAutoHint          (var _Data:TData; Index:word);
    procedure _work_doShowPosAsPct      (var _Data:TData; Index:word);
    procedure _work_doCaption           (var _Data:TData; Index:word);
// Border
    procedure _work_doShape             (var _Data:TData; Index:word);
    procedure _work_doShapeColor        (var _Data:TData; Index:word);
    procedure _work_doRound             (var _Data:TData; Index:word);
            
    procedure _var_Position             (var _Data:TData; Index:word);
  end;

implementation

procedure THIQProgressBar.Init;
begin
   Control := NewQProgressBar(FParent);
   Control.MaxProgress := _prop_Max;
   Control.Caption := _prop_Caption;
   inherited;
   {$ifdef F_P}
  with PQProgressBar(Control) do
  {$else}
  with PQProgressBar(Control)^ do
  {$endif}
   begin
     BarKind           :=  arr_Style[_prop_Style];
     BarLook           :=  arr_Look[_prop_Look];     
     Orientation       :=  arr_Kind[_prop_Kind];
     CaptionAlign      :=  arr_Align[_prop_Alignment];     
     RoundCorner       :=  _prop_Round;
     BackgroundColor   :=  _prop_Color;
     StartColor        :=  _prop_StartColor;
     FinalColor        :=  _prop_FinalColor;
     ShowInactivePos   :=  _prop_InactivePos;     
     InvertInactPos    :=  _prop_InvertInactPos; 
     InactivePosColor  :=  _prop_InactivePosColor;
     Shaped            :=  _prop_Shape;
     ShapeColor        :=  _prop_ShapeColor;
     BlockSize         :=  _prop_BlockSize;
     SpaceSize         :=  _prop_SpaceSize;
     ShowFullBlock     :=  _prop_ShowFullBlock;
     HideOnTerminate   :=  _prop_HideOnTerminate;
     AutoCaption       :=  _prop_AutoCaption;
     AutoHint          :=  _prop_AutoHint;     
     ShowPosAsPct      :=  _prop_ShowPosAsPct;   
   end;
end;

procedure THIQProgressBar._work_doPosition;          begin Control.Progress                         :=  ReadInteger(_data,null,0); end;
procedure THIQProgressBar._work_doMax;               begin Control.MaxProgress                      :=  ReadInteger(_data,null,0); end;
procedure THIQProgressBar._work_doColor;             begin PQProgressBar(Control).BackgroundColor   :=  ToInteger(_Data); end;
procedure THIQProgressBar._work_doKind; 
begin 
  _prop_Kind := ToInteger(_Data); 
  PQProgressBar(Control).Orientation := arr_Kind[_prop_Kind];
end;
// All
procedure THIQProgressBar._work_doBlockSize;         begin PQProgressBar(Control).BlockSize         :=  ToInteger(_Data); end;
procedure THIQProgressBar._work_doSpaceSize;         begin PQProgressBar(Control).SpaceSize         :=  ToInteger(_Data); end;
procedure THIQProgressBar._work_doShowFullBlock;     begin PQProgressBar(Control).ShowFullBlock     :=  ReadBool(_Data); end;
procedure THIQProgressBar._work_doHideOnTerminate;   begin PQProgressBar(Control).HideOnTerminate   :=  ReadBool(_Data); end;
// Gradient
procedure THIQProgressBar._work_doStyle;
begin
  _prop_Style := ToInteger(_Data);
  PQProgressBar(Control).BarKind := arr_Style[_prop_Style];
end;
procedure THIQProgressBar._work_doLook;
begin
  _prop_Look := ToInteger(_Data);
  PQProgressBar(Control).BarLook := arr_Look[_prop_Look];
end;
procedure THIQProgressBar._work_doStartColor;        begin PQProgressBar(Control).StartColor        :=  ToInteger(_Data); end;
procedure THIQProgressBar._work_doFinalColor;        begin PQProgressBar(Control).FinalColor        :=  ToInteger(_Data); end;
procedure THIQProgressBar._work_doInactivePos;       begin PQProgressBar(Control).ShowInactivePos   :=  ReadBool(_Data); end;
procedure THIQProgressBar._work_doInvertInactPos;    begin PQProgressBar(Control).InvertInactPos    :=  ReadBool(_Data); end;
procedure THIQProgressBar._work_doInactivePosColor;  begin PQProgressBar(Control).InactivePosColor  :=  ToInteger(_Data); end;
// Text
procedure THIQProgressBar._work_doAlignment;
begin
  _prop_Alignment := ToInteger(_Data);
  PQProgressBar(Control).CaptionAlign := arr_Align[_prop_Alignment];
end;
procedure THIQProgressBar._work_doAutoCaption;       begin PQProgressBar(Control).AutoCaption       :=  ReadBool(_Data); end;
procedure THIQProgressBar._work_doAutoHint;          begin PQProgressBar(Control).AutoHint          :=  ReadBool(_Data); end;
procedure THIQProgressBar._work_doShowPosAsPct;      begin PQProgressBar(Control).ShowPosAsPct      :=  ReadBool(_Data); end;
procedure THIQProgressBar._work_doCaption;           begin Control.Caption                          :=  ToString(_Data); end;
// Border
procedure THIQProgressBar._work_doShape;             begin PQProgressBar(Control).Shaped            :=  ReadBool(_Data); end;
procedure THIQProgressBar._work_doShapeColor;        begin PQProgressBar(Control).ShapeColor        :=  ToInteger(_Data); end;
procedure THIQProgressBar._work_doRound;             begin PQProgressBar(Control).RoundCorner       :=  ReadBool(_Data); end;

procedure THIQProgressBar._var_Position;             begin dtInteger(_Data,Control.Progress); end;

end.